/**************************************************************************/
/*  parchig.c Version 4.1 Modulo de parchis.c                             */
/*  Copyright (C) 1992, 1999, 2007, 2017 Mariano Alvarez Fernandez        */
/*  Lea en el fichero LEEME.TXT los detalles                              */
/*  See README.TXT for details                                            */
/**************************************************************************/
/*  Rutinas de la presentacion grafica                                    */
/**************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <mgrx.h>
#include <mgrxkeys.h>
#include "grsound.h"
#include "gfaz.h"
#include "parchit.h"
#include "parchig.h"
#include "idiomas.h"

static int glob_tc;
static char glob_ts[30];
static int glob_xqj, glob_yqj;

static GrFont * grf_normal;
static GrFont * grf_grande;
static GrFont * grf_texto;

static GrContext * grc_tablero;

static GrContext * grc_dibf[4];
static GrContext * grc_dibfcruz[4];
static GrContext * grc_dibfmascara;
static GrContext * grc_dibfviejo[4][4];

static GrContext * grc_dibdado[6];
static GrContext * grc_dibdadomascara;
static GrContext * grc_dibdadoxx;
static GrContext * grc_dibdado10;
static GrContext * grc_dibdado20;

static GrContext * grc_dibnam;
static GrContext * grc_dibnammascara;
static GrContext * grc_dibnamviejo;

static struct PosG casa[4][4];
static struct PosG corredor[68][2];
static struct PosG llegada[4][7][2];
static struct PosG meta[4][4];

static GrColor colores_tbl[4];
  
static struct PosG gci = { 490,320 };
static struct PosG gcf = { 599,397 };
static struct PosG tfi[4] = { {549,375}, {549,396}, {549,417}, {549,438} };
static struct PosG tff[4] = { {599,397}, {599,418}, {599,439}, {599,460} };
static struct PosG tgi[4] = { {490,375}, {490,396}, {490,417}, {490,438} };
static struct PosG tgf[4] = { {550,397}, {550,418}, {550,439}, {550,460} };

/**************************************************************************/

void inicia_tablerog( void )
{
  int i, posx, posy;
  int x1, x2, x3, x4, x5, y1, y2, y3, y4, y5;

  for( i=0; i<8; i++ ){
    posx = 426 - i * 20;
    corredor[i][0].x = posx; corredor[i][0].y = 198;
    corredor[i][1].x = posx; corredor[i][1].y = 174;
    }
  for( i=8; i<16; i++ ){
    posy = 173 - (i - 8) * 20;
    corredor[i][0].x = 261; corredor[i][0].y = posy;
    corredor[i][1].x = 285; corredor[i][1].y = posy;
    }
  corredor[16][0].x = 215; corredor[16][0].y = 33;
  corredor[16][1].x = 239; corredor[16][1].y = 33;
  for( i=17; i<25; i++ ){
    posy = 33 + (i - 17) * 20;
    corredor[i][0].x = 193; corredor[i][0].y = posy;
    corredor[i][1].x = 169; corredor[i][1].y = posy;
    }
  for( i=25; i<33; i++ ){
    posx = 168 - (i - 25) * 20;
    corredor[i][0].x = posx; corredor[i][0].y = 198;
    corredor[i][1].x = posx; corredor[i][1].y = 174;
    }
  corredor[33][0].x = 28; corredor[33][0].y = 220;
  corredor[33][1].x = 28; corredor[33][1].y = 244;
  for( i=34; i<42; i++ ){
    posx = 28 + (i - 34) * 20;
    corredor[i][0].x = posx; corredor[i][0].y = 266;
    corredor[i][1].x = posx; corredor[i][1].y = 290;
    }
  for( i=42; i<50; i++ ){
    posy = 291 + (i - 42) * 20;
    corredor[i][0].x = 193; corredor[i][0].y = posy;
    corredor[i][1].x = 169; corredor[i][1].y = posy;
    }
  corredor[50][0].x = 215; corredor[50][0].y = 431;
  corredor[50][1].x = 239; corredor[50][1].y = 431;
  for( i=51; i<59; i++ ){
    posy = 431 - (i - 51) * 20;
    corredor[i][0].x = 261; corredor[i][0].y = posy;
    corredor[i][1].x = 285; corredor[i][1].y = posy;
    }
  for( i=59; i<67; i++ ){
    posx = 286 + (i - 59) * 20;
    corredor[i][0].x = posx; corredor[i][0].y = 266;
    corredor[i][1].x = posx; corredor[i][1].y = 290;
    }
  corredor[67][0].x = 426; corredor[67][0].y = 220;
  corredor[67][1].x = 426; corredor[67][1].y = 244;

  casa[0][0].x = corredor[ 4][0].x; casa[0][0].y = corredor[13][0].y;
  casa[0][1].x = corredor[ 2][0].x; casa[0][1].y = corredor[13][0].y;
  casa[0][2].x = corredor[ 4][0].x; casa[0][2].y = corredor[11][0].y;
  casa[0][3].x = corredor[ 2][0].x; casa[0][3].y = corredor[11][0].y;
  casa[1][0].x = corredor[30][0].x; casa[1][0].y = corredor[19][0].y;
  casa[1][1].x = corredor[28][0].x; casa[1][1].y = corredor[19][0].y;
  casa[1][2].x = corredor[30][0].x; casa[1][2].y = corredor[21][0].y;
  casa[1][3].x = corredor[28][0].x; casa[1][3].y = corredor[21][0].y;
  casa[2][0].x = corredor[36][0].x; casa[2][0].y = corredor[45][0].y;
  casa[2][1].x = corredor[38][0].x; casa[2][1].y = corredor[45][0].y;
  casa[2][2].x = corredor[36][0].x; casa[2][2].y = corredor[47][0].y;
  casa[2][3].x = corredor[38][0].x; casa[2][3].y = corredor[47][0].y;
  casa[3][0].x = corredor[62][0].x; casa[3][0].y = corredor[55][0].y;
  casa[3][1].x = corredor[64][0].x; casa[3][1].y = corredor[55][0].y;
  casa[3][2].x = corredor[62][0].x; casa[3][2].y = corredor[53][0].y;
  casa[3][3].x = corredor[64][0].x; casa[3][3].y = corredor[53][0].y;

  for( i=0; i<7; i++ ){
    posx = 406 - i * 20;
    llegada[0][i][0].x = posx; llegada[0][i][0].y = 219;
    llegada[0][i][1].x = posx; llegada[0][i][1].y = 243;
    }
  for( i=0; i<7; i++ ){
    posy = 53 + i * 20;
    llegada[1][i][0].x = 215; llegada[1][i][0].y = posy;
    llegada[1][i][1].x = 239; llegada[1][i][1].y = posy;
    }
  for( i=0; i<7; i++ ){
    posx = 48 + i * 20;
    llegada[2][i][0].x = posx; llegada[2][i][0].y = 219;
    llegada[2][i][1].x = posx; llegada[2][i][1].y = 243;
    }
  for( i=0; i<7; i++ ){
    posy = 411 - i * 20;
    llegada[3][i][0].x = 215; llegada[3][i][0].y = posy;
    llegada[3][i][1].x = 239; llegada[3][i][1].y = posy;
    }

  x1 = 188; x2 = 208; x3 = 228; x4 = 248; x5 = 268;
  y1 = 193; y2 = 213; y3 = 233; y4 = 253; y5 = 273;
  meta[0][0].x = x5-2; meta[0][0].y = y2;
  meta[0][1].x = x5-2; meta[0][1].y = y3;
  meta[0][2].x = x5-2; meta[0][2].y = y4;
  meta[0][3].x = x4-2; meta[0][3].y = y3;
  meta[1][0].x = x2; meta[1][0].y = y1;
  meta[1][1].x = x3; meta[1][1].y = y1;
  meta[1][2].x = x4; meta[1][2].y = y1;
  meta[1][3].x = x3; meta[1][3].y = y2;
  meta[2][0].x = x1; meta[2][0].y = y2;
  meta[2][1].x = x1; meta[2][1].y = y3;
  meta[2][2].x = x1; meta[2][2].y = y4;
  meta[2][3].x = x2; meta[2][3].y = y3;
  meta[3][0].x = x2; meta[3][0].y = y5-2;
  meta[3][1].x = x3; meta[3][1].y = y5-2;
  meta[3][2].x = x4; meta[3][2].y = y5-2;
  meta[3][3].x = x3; meta[3][3].y = y4-2;
}

/*************************************************************************/

void carga_tablero( void )
{
  unsigned char b;
  int i, j, ind;
  GrContext grc_anterior;

  grc_tablero = GrCreateContext( 439,439,NULL,NULL );
  if( grc_tablero == NULL ) termina_mal( "Falta memoria (out of memory)" );
  GrSaveContext( &grc_anterior );
  GrSetContext( grc_tablero );
  ind = 0;
  for( j = 0; j < 439; j++ ){
    for( i = 0; i < 439; i++ ){
      GrPlot( i,j,colores[bindata_parc[ind++]] );
      }
    }
  GrSetContext( &grc_anterior );
}

/*************************************************************************/

void carga_figuras( void )
{
  unsigned char b;
  int k, i, j, ind;
  GrContext grc_anterior, *grc_ficha[9];

  GrSaveContext( &grc_anterior );
  ind = 0;
  for( k=0; k<9; k++ ){
    grc_ficha[k] = GrCreateContext( 19,19,NULL,NULL );
    if( grc_ficha[k] == NULL ) termina_mal( "Falta memoria (out of memory)" );
    GrSetContext( grc_ficha[k] );
    for( j = 0; j < 19; j++ ){
      for( i = 0; i < 19; i++ ){
        GrPlot( i,j,colores[bindata_fig[ind++]] );
        }
      }
    }
  GrSetContext( &grc_anterior );

  grc_dibf[0] = grc_ficha[0];
  grc_dibf[1] = grc_ficha[1];
  grc_dibf[2] = grc_ficha[2];
  grc_dibf[3] = grc_ficha[3];
  grc_dibfcruz[0] = grc_ficha[4];
  grc_dibfcruz[1] = grc_ficha[5];
  grc_dibfcruz[2] = grc_ficha[6];
  grc_dibfcruz[3] = grc_ficha[7];
  grc_dibfmascara = grc_ficha[8];

  for( i=0; i<4; i++ )
    for( j=0; j<4; j++ ){
      grc_dibfviejo[i][j] = GrCreateContext( 19,19,NULL,NULL );
      if( grc_dibfviejo[i][j] == NULL )
        termina_mal( "Falta memoria (out of memory)" );
      }
}

/*************************************************************************/

void carga_dados( void )
{
  unsigned char b;
  int k, i, j, ind;
  GrContext grc_anterior, *grc_dado[12];

  GrSaveContext( &grc_anterior );
  ind = 0;
  for( k=0; k<12; k++ ){
    grc_dado[k] = GrCreateContext( 41,41,NULL,NULL );
    if( grc_dado[k] == NULL )  termina_mal( "Falta memoria (out of memory)" );
    GrSetContext( grc_dado[k] );
    for( j = 0; j < 41; j++ ){
      for( i = 0; i < 41; i++ ){
        GrPlot( i,j,colores[bindata_fig2[ind++]] );
        }
      }
    }
  GrSetContext( &grc_anterior );

  grc_dibdado[0] = grc_dado[0];
  grc_dibdado[1] = grc_dado[1];
  grc_dibdado[2] = grc_dado[2];
  grc_dibdado[3] = grc_dado[3];
  grc_dibdado[4] = grc_dado[4];
  grc_dibdado[5] = grc_dado[5];
  grc_dibdadomascara = grc_dado[6];
  grc_dibdadoxx = grc_dado[7];
  grc_dibdado10 = grc_dado[8];
  grc_dibdado20 = grc_dado[9];
  grc_dibnam = grc_dado[10];
  grc_dibnammascara = grc_dado[11];
  
  grc_dibnamviejo = GrCreateContext( 41,41,NULL,NULL );
  if( grc_dibnamviejo == NULL )
    termina_mal( "Falta memoria (out of memory)" );
}

/**************************************************************************/

void inicia_graficos( void )
{
  inicia_tablerog();
  carga_tablero();
  carga_figuras();
  carga_dados();

  grf_normal = &font_lucb27;
  grf_grande = &font_lucb40b;
  grf_texto = &font_gamo08b;
  gfaz_setfont(grf_texto);

  colores_tbl[0] = K_YELLOW;
  colores_tbl[1] = K_LIGHTBLUE;
  colores_tbl[2] = K_LIGHTRED;
  colores_tbl[3] = K_GREEN;
}
  
/**************************************************************************/

void pantalla_inicial( void )
{
  GrTextOption grt;
  char *t1 = "Parchís";
  char *t2 = "Versión 4.1";
  char *t3 = "Copyright (C) 1992-2017, M.Alvarez";

  grt.txo_fgcolor = K_BLACK;
  grt.txo_bgcolor = K_BLACK | GrOR;
  grt.txo_direct = GR_TEXT_RIGHT;
  grt.txo_xalign = GR_ALIGN_CENTER;
  grt.txo_yalign = GR_ALIGN_CENTER;
  grt.txo_chrtype = GR_UTF8_TEXT;
  
//  oculta_raton();
  GrClearContext( K_LIGHTGRAY );

  GrFilledBox( 1,1,318,238,K_LIGHTBLUE );
  GrFilledBox( 321,1,638,238,K_YELLOW );
  GrFilledBox( 1,241,318,478,K_LIGHTRED );
  GrFilledBox( 321,241,638,478,K_GREEN );

  grt.txo_font = grf_grande;
  GrDrawString( t1,0,319,300,&grt );
  grt.txo_font = grf_normal;
  GrDrawString( t2,0,319,360,&grt );
  GrDrawString( t3,0,319,400,&grt );

//  muestra_raton();
}

/**************************************************************************/

void dibuja_pantalla( void )
{
  GrTextOption grt;

//  oculta_raton();
  GrClearContext( K_LIGHTGRAY );

  dibuja_tablero();

  grt.txo_fgcolor = K_BLUE;
  grt.txo_bgcolor = K_BLACK | GrOR;
  grt.txo_direct = GR_TEXT_RIGHT;
  grt.txo_xalign = GR_ALIGN_CENTER;
  grt.txo_yalign = GR_ALIGN_CENTER;
  grt.txo_chrtype = GR_UTF8_TEXT;

  grt.txo_font = grf_grande;
  GrDrawString( "Parchís",7,545,50,&grt );

  dibuja_botones();
//  muestra_raton();
}

/**************************************************************************/

void dibuja_tablero( void )
{
//  oculta_raton();
  GrBitBlt( NULL,17,22,grc_tablero,0,0,438,438,GrWRITE );
//  muestra_raton();
}

/**************************************************************************/

void dibuja_botones( void )
{
  static int x = 490, y = 118;
  int i;

//  oculta_raton();
  dboton( x,y,56,50,K_GREEN,K_BLACK,SB_AYUDA,0 );
  dboton( x+54,y,56,50,K_GREEN,K_BLACK,SB_INFO,0 );
  dboton( x,y+48,56,50,K_GREEN,K_BLACK,SB_NUEVO,0 );
  dboton( x+54,y+48,56,50,K_GREEN,K_BLACK,SB_SALIR,0 );
  dboton( x,y+96,56,50,K_GREEN,K_BLACK,SB_FICHA,0 );
  dboton( x+54,y+96,56,50,K_GREEN,K_BLACK,SB_RUIDO,0 );

  GrBox( gci.x,gci.y,gcf.x,gcf.y,K_BLACK );
  GrBox( gci.x+1,gci.y+1,gcf.x-1,gcf.y-1,K_BLACK );
  for( i=0; i<4; i++ ){
    GrBox( tgi[i].x,tgi[i].y,tgf[i].x,tgf[i].y,K_BLACK );
    GrBox( tgi[i].x+1,tgi[i].y+1,tgf[i].x-1,tgf[i].y-1,K_BLACK );
    GrFilledBox( tgi[i].x+2,tgi[i].y+2,tgf[i].x-2,tgf[i].y-2,colores_tbl[i] );
    GrBox( tfi[i].x,tfi[i].y,tff[i].x,tff[i].y,K_BLACK );
    GrBox( tfi[i].x+1,tfi[i].y+1,tff[i].x-1,tff[i].y-1,K_BLACK );
    GrFilledBox( tfi[i].x+2,tfi[i].y+2,tff[i].x-2,tff[i].y-2,K_WHITE );
    }
//  muestra_raton();
}

/**************************************************************************/

void quita_fichag( int color, int nficha, struct Posicion *p )
{
  struct PosG pg;

  if( p->lugar == CASA )
    pg = casa[color][p->ind];
  else if( p->lugar == CORREDOR )
    pg = corredor[p->pos][p->ind];
  else if( p->lugar == LLEGADA )
    pg = llegada[color][p->pos][p->ind];
  else
    pg = meta[color][p->ind];

//  oculta_raton();
  GrBitBlt( NULL,pg.x,pg.y,grc_dibfviejo[color][nficha],0,0,18,18,GrWRITE );
//  muestra_raton();
}

/**************************************************************************/

void pon_fichag( int color, int nficha, struct Posicion *p )
{
  struct PosG pg;

  if( p->lugar == CASA )
    pg = casa[color][p->ind];
  else if( p->lugar == CORREDOR )
    pg = corredor[p->pos][p->ind];
  else if( p->lugar == LLEGADA )
    pg = llegada[color][p->pos][p->ind];
  else
    pg = meta[color][p->ind];

//  oculta_raton();
  GrBitBlt( grc_dibfviejo[color][nficha],0,0,NULL,
            pg.x,pg.y,pg.x+18,pg.y+18,GrWRITE );
  GrBitBlt( NULL,pg.x,pg.y,grc_dibfmascara,0,0,18,18,GrAND );
  GrBitBlt( NULL,pg.x,pg.y,grc_dibf[color],0,0,18,18,GrOR );
//  muestra_raton();
}

/**************************************************************************/

void pon_cruzg( int color, struct Posicion *p, int pon )
{
  struct PosG pg;

  if( p->lugar == CASA )
    pg = casa[color][p->ind];
  else if( p->lugar == CORREDOR )
    pg = corredor[p->pos][p->ind];
  else if( p->lugar == LLEGADA )
    pg = llegada[color][p->pos][p->ind];
  else
    pg = meta[color][p->ind];

//  oculta_raton();
  GrBitBlt( NULL,pg.x,pg.y,grc_dibfmascara,0,0,18,18,GrAND );
  if( pon )
    GrBitBlt( NULL,pg.x,pg.y,grc_dibfcruz[color],0,0,18,18,GrOR );
  else
    GrBitBlt( NULL,pg.x,pg.y,grc_dibf[color],0,0,18,18,GrOR );
//  muestra_raton();
}

/**************************************************************************/

void pon_nam( struct Posicion *p, int espera )
{
  struct PosG pg;

  if( p->lugar != CORREDOR ) return;
  pg = corredor[p->pos][p->ind];
  pg.x -= 10;
  pg.y -= 10;

//  oculta_raton();
  GrBitBlt( grc_dibnamviejo,0,0,NULL,
            pg.x,pg.y,pg.x+40,pg.y+40,GrWRITE );
  GrBitBlt( NULL,pg.x,pg.y,grc_dibnammascara,0,0,40,40,GrAND );
  GrBitBlt( NULL,pg.x,pg.y,grc_dibnam,0,0,40,40,GrOR );
  GrSoundPlaySound( 20,espera/3 );
  GrSoundPlaySound( 22,espera/3 );
  GrSoundPlaySound( 24,espera/3 );
  GrBitBlt( NULL,pg.x,pg.y,grc_dibnamviejo,0,0,40,40,GrWRITE );
//  muestra_raton();
}

/**************************************************************************/

void traslada_fichag( int color, int nficha, struct Posicion *p1,
                      struct Posicion *p2 )
{
//  oculta_raton();
  quita_fichag( color,nficha,p1 );
  pon_fichag( color,nficha,p2 );
//  muestra_raton();
}

/**************************************************************************/

void situa_fichasg( struct Tablero *tbl )
{
  int i, j;

//  oculta_raton();
  for( i=AMAR; i<=VERD; i++ )
    for( j=0; j<4; j++ )
      pon_fichag( i,j,&(tbl->jugador[i].ficha[j]) );
  pinta_estadisticas( tbl );
//  muestra_raton();
}

/**************************************************************************/

void quita_fichasg( struct Tablero *tbl )
{
  int i, j;

//  oculta_raton();
  for( i=AMAR; i<=VERD; i++ )
    for( j=0; j<4; j++ )
      quita_fichag( i,j,&(tbl->jugador[i].ficha[j]) );
//  muestra_raton();
}

/**************************************************************************/

void mueve_fichasg( struct Tablero *tbl1, struct Tablero *tbl2,
                    struct Jugada *jugada, int jfin )
{
  struct Posicion posini, posfin;
  int mf[4][4] = { {0,0,0,0}, {0,0,0,0}, {0,0,0,0}, {0,0,0,0} };
  int i, j;

//  oculta_raton();
  for( i=AMAR; i<=VERD; i++ )
    for( j=0; j<4; j++ )
      if( !compara_posicion( &(tbl1->jugador[i].ficha[j]),
                             &(tbl2->jugador[i].ficha[j]) ) ) mf[i][j] = 1;

  if( jugada->cjugador != VACIO ){
    mf[jugada->cjugador][jugada->nficha] = 0;
    if( jugada->anal.come )
      mf[jugada->cjugdcom][jugada->nfichcom] = 0;
    posini = jugada->origen;
    quita_fichag( jugada->cjugador,jugada->nficha,&posini );
    if( !jugada->anal.entra ){
      for( i=0; i< jugada->vdado-1; i++ ){
        paso_adelante( jugada->cjugador,&posini,&posfin );
        pon_fichag( jugada->cjugador,jugada->nficha,&posfin );
        posini = posfin;
        GrSleep( 1 );
        GrSoundPlaySound( i+12,80 );
        GrSleep( 20 );
        quita_fichag( jugada->cjugador,jugada->nficha,&posfin );
        }
      }
      if( jugada->anal.come )
        quita_fichag( jugada->cjugdcom,jugada->nfichcom,&(jugada->destino) );
      pon_fichag( jugada->cjugador,jugada->nficha,&(jugada->destino) );
      GrSoundPlaySound( 10,80 );
      GrSleep( 20 );
    if( jugada->anal.come ){
      pon_fichag( jugada->cjugdcom,jugada->nfichcom,
        &(tbl2->jugador[jugada->cjugdcom].ficha[jugada->nfichcom]) );
      pon_nam( &(jugada->destino),420 );
      GrSleep( 200 );
      pon_nam( &(jugada->destino),420 );
      }
    if( jugada->anal.meta ){
      GrSoundSetOctave( 4 );
      for( i=0; i< 12; i++ )
        GrSoundPlayNote( i,30 );
      }
    }

  for( i=AMAR; i<=VERD; i++ )
    for( j=0; j<4; j++ )
      if( mf[i][j] )
        quita_fichag( i,j,&(tbl1->jugador[i].ficha[j]) );
  for( i=AMAR; i<=VERD; i++ )
    for( j=0; j<4; j++ )
      if( mf[i][j] )
        pon_fichag( i,j,&(tbl2->jugador[i].ficha[j]) );
  if( jfin ) ha_llegado( 177,138,tbl2 );
  pinta_estadisticas( tbl2 );
//  muestra_raton();
}

/**************************************************************************/

void ruido_a_casa( void )
{
  int i;

  GrSoundSetOctave( 3 );
  for( i=11; i>= 0; i-- )
    GrSoundPlayNote( i,20 );
}

/**************************************************************************/

int elige_jugadag( struct Tablero *tbl, struct JugadasPosibles *jpo,
                    struct Jugada *jugada )
{
  int cj, nf, nj, incr, ev, c;
  cj = jpo->jugada[0].cjugador;
  nf = jpo->jugada[0].nficha;
  nj = 0;
  pon_cruzg( cj,&(tbl->jugador[cj].ficha[nf]),1 );
  while( 1 ){
    incr = 0;
    ev = lee_orden( tbl,&c,1 );
    if( ev == -1 ) return 1;
    cecr( jpo,nj,&ev,(unsigned int *)&c,&incr );
    if( ev == EV_TECLA ){
      if( c == GrKey_Return ) break;
      switch( c ){
        case GrKey_Left: incr = -1; break;
        case GrKey_Right: incr = 1; break;
        }
      }
    if( incr != 0 ){
      nj = nj + incr;
      if( nj < 0 ) nj = jpo->njugadas - 1;
      if( nj >= jpo->njugadas ) nj = 0;
      pon_cruzg( cj,&(tbl->jugador[cj].ficha[nf]),0 );
      nf = jpo->jugada[nj].nficha;
      pon_cruzg( cj,&(tbl->jugador[cj].ficha[nf]),1 );
      }
    }
  pon_cruzg( cj,&(tbl->jugador[cj].ficha[nf]),0 );
  *jugada = jpo->jugada[nj];
  return 0;
}

/**************************************************************************/

void cecr( struct JugadasPosibles *jpo, int nj,
           int *ev, unsigned int *c, int *incr )
{
  struct Posicion p;
  unsigned int i, b1, b2;
  int clleg = VACIO;

  if( *ev != EV_AREA ) return;
  b1 = *c >> 8; /***/
  b2 = *c & 0xFF;
  if( b1 < 1 || b2 < 1 || b2 > 2 ) return;
  *c = 0;

  if( b1 < 100 ){
    p.lugar = CORREDOR;
    p.pos = b1 - 1;
    p.ind = b2 - 1;
    }
  if( b1 > 100 && b1 < 140 ){
    clleg = (b1 - 100) / 10;
    p.lugar = LLEGADA;
    p.pos = b1 - 101 - clleg * 10;
    p.ind = b2 - 1;
    }
  if( b1 == 150 ){
    p.lugar = META;
    }

  /* Mira si coincide con la posicion de alguna ficha, entonces
     modifica incr para que apunte a ella */

  for( i=0; i<jpo->njugadas; i++ ){
    if( compara_poselige( &(jpo->jugada[i].origen),&p,1 ) ){
      if( p.lugar != LLEGADA || jpo->jugada[i].cjugador == clleg ){
        *incr = i - nj;
        return;
        }
      }
    }

  /* Mira si coincide la posicion con el destino, entonces devuelve
     evento de tecla y RETORNO en c */

  if( compara_poselige( &(jpo->jugada[nj].destino),&p,0 ) ){
    if( p.lugar != LLEGADA || jpo->jugada[nj].cjugador == clleg ){
      *ev = EV_TECLA;
      *c = GrKey_Return;
      return;
      }
    }

  /* No vale, pita */
  GrSoundPlaySound( 16,80 );
}

/**************************************************************************/

int compara_poselige( struct Posicion *p1, struct Posicion *p2, int vind )
{
  if( p1->lugar == p2->lugar ){
    if( p2->lugar == META )
      return 1;
    if( p1->pos == p2->pos ){
      if( !vind ) return 1;
      if( p1->ind == p2->ind ) return 1;
      }
    }
  return 0;
}

/**************************************************************************/

void pinta_jugadam( struct Tablero *tbl, struct Jugada *jugada )
{
  int i, cj, nf;

  cj = jugada->cjugador;
  nf = jugada->nficha;
  for( i=0; i<5; i++ ){
    pon_cruzg( cj,&(tbl->jugador[cj].ficha[nf]),1 );
    GrSleep( 200 );
    pon_cruzg( cj,&(tbl->jugador[cj].ficha[nf]),0 );
    GrSleep( 200 );
    }
}

/**************************************************************************/

void pinta_dado( int vdado )
{
  static int x = 524, y = 329;
  int i, j;

//  oculta_raton();
  if( vdado > 0 && vdado < 8 ){
    vdado--;
    if( vdado == 6 ) vdado = 5;
    for( i=0; i< 3; i++ )
      for( j=0; j<6; j++ ){
        GrBitBlt( NULL,x,y,grc_dibdadomascara,0,0,40,40,GrAND );
        GrBitBlt( NULL,x,y,grc_dibdado[j],0,0,40,40,GrOR );
//        muestra_raton();
        GrSoundPlaySound( 4,25 );
        GrSoundPlaySound( 16,25 );
//        oculta_raton();
        }
    GrBitBlt( NULL,x,y,grc_dibdadomascara,0,0,40,40,GrAND );
    GrBitBlt( NULL,x,y,grc_dibdado[vdado],0,0,40,40,GrOR );
//    muestra_raton();
    return;
  }
  if( vdado == 10 ){
    GrBitBlt( NULL,x,y,grc_dibdadomascara,0,0,40,40,GrAND );
    GrBitBlt( NULL,x,y,grc_dibdado10,0,0,40,40,GrOR );
//    muestra_raton();
    return;
    }
  if( vdado == 20 ){
    GrBitBlt( NULL,x,y,grc_dibdadomascara,0,0,40,40,GrAND );
    GrBitBlt( NULL,x,y,grc_dibdado20,0,0,40,40,GrOR );
//    muestra_raton();
    return;
    }
  GrBitBlt( NULL,x,y,grc_dibdadomascara,0,0,40,40,GrAND );
  GrBitBlt( NULL,x,y,grc_dibdadoxx,0,0,40,40,GrOR );
//  muestra_raton();
}

/**************************************************************************/

void pinta_tirador( int color, char *s )
{
  glob_tc = color;
  strcpy( glob_ts,s );

//  oculta_raton();
  dboton( 490,295,110,28,colores_tbl[color],K_BLACK,s,0 );
//  muestra_raton();
}

/************************************************************************/

void pinta_estadisticas( struct Tablero *tbl )
{
  static char *tfj[4];
  GrTextOption grt;
  int i;
  char s[21];

  tfj[0] = SE_PRIMERO;
  tfj[1] = SE_SEGUNDO;
  tfj[2] = SE_TERCERO;
  tfj[3] = SE_ULTIMO;

//  oculta_raton();
//  grt.txo_font = &GrFont_PC8x16;
  grt.txo_font = grf_texto;
  grt.txo_fgcolor = K_BLACK;
  grt.txo_bgcolor = K_BLACK | GrOR;
  grt.txo_direct = GR_TEXT_RIGHT;
  grt.txo_xalign = GR_ALIGN_CENTER;
  grt.txo_yalign = GR_ALIGN_CENTER;
  grt.txo_chrtype = GR_UTF8_TEXT;

  for( i=AMAR; i<=VERD; i++ ){
    GrFilledBox( tfi[i].x+2,tfi[i].y+2,tff[i].x-2,tff[i].y-2,K_WHITE );
    if( tbl->jugador[i].tipo != NOJUEGA ){
      sprintf( s,"%i-%i-%i",tbl->resumen[i].nfcasa,tbl->resumen[i].nftbl,
               tbl->resumen[i].nfmeta );
      GrDrawString( s,0,tfi[i].x+24,tfi[i].y+12,&grt );
      }
    GrFilledBox( tgi[i].x+2,tgi[i].y+2,tgf[i].x-2,tgf[i].y-2,colores_tbl[i] );
    if( tbl->orden_final[i] > -1 )
      GrDrawString( tfj[tbl->orden_final[i]],0,
                    tgi[i].x+30,tgi[i].y+12,&grt );
    }
//  muestra_raton();
}

/************************************************************************/

int quien_juega( int x, int y, int *j1, int *j2, int *j3, int *j4 )
{
  static char *titulo[3];
  GrContext * grc;
  GrTextOption grt;
  GrColor ct;
  int pintar[4][3] = { {1,1,1}, {1,1,1}, {1,1,1}, {1,1,1} };
  int i, j, t, ev, c, b1, b2;
  int opc[4], cselec = 0;

  titulo[0] = SQ_PERSONA;
  titulo[1] = SQ_MAQUINA;
  titulo[2] = SQ_NOJUEGA;

  opc[0] = *j1; opc[1] = *j2; opc[2]= *j3; opc[3] = *j4;

//  oculta_raton();
  asigna_raton2( x,y );

  grc = GrCreateContext( 286,237,NULL,NULL );
  if( grc == NULL ) termina_mal( "Falta memoria (out of memory)" );
  GrBitBlt( grc,0,0,NULL,x,y,x+285,y+236,GrWRITE );

  GrBox( x,y,x+285,y+236,K_BLACK );
  GrBox( x+1,y+1,x+284,y+235,K_CYAN );
  GrBox( x+2,y+2,x+283,y+234,K_CYAN );
  GrBox( x+3,y+3,x+282,y+233,K_BLACK );
  GrFilledBox( x+4,y+4,x+281,y+232,K_WHITE );

  grt.txo_font = grf_normal;
  grt.txo_fgcolor = K_BLACK;
  grt.txo_bgcolor = K_BLACK | GrOR;
  grt.txo_direct = GR_TEXT_RIGHT;
  grt.txo_xalign = GR_ALIGN_CENTER;
  grt.txo_yalign = GR_ALIGN_CENTER;
  grt.txo_chrtype = GR_UTF8_TEXT;
  GrDrawString( SQ_TEXTO,0,x+286/2,y+18,&grt );
  
  dboton( x+10,y+200,90,30,K_LIGHTGRAY,K_BLACK,SB_CANCELAR,0 );
  dboton( x+186,y+200,90,30,K_LIGHTGRAY,K_BLACK,SB_VALE,0 );
//  muestra_raton();

  while( 1 ){
    for( i=0; i<4; i++ )
      for( j=0; j<3; j++ )
        if( pintar[i][j] ){
//          oculta_raton();
          t = (j == opc[i]) ? 1 : 0;
          if( t && i == cselec ) t = 3;
          ct = ( t ) ? K_BLACK : K_LIGHTGRAY;
          dboton( x+10+j*88,y+40+i*38,90,40,colores_tbl[i],ct,titulo[j],t );
          pintar[i][j] = 0;
//          muestra_raton();
          }
    ev = lee_evento( &c,1 );
    if( ev == EV_TECLA ){
      if( (c == 'C') || (c == GrKey_Escape) ) break;
      if( (c == 'V') || (c == GrKey_Return) ) break;
      pintar[cselec][opc[cselec]] = 1;
      switch( c ){
        case GrKey_Left : opc[cselec] = max( 0,opc[cselec]-1 ); break;
        case GrKey_Right: opc[cselec] = min( 2,opc[cselec]+1 ); break;
        case GrKey_Up   : cselec = max( 0,cselec-1 ); break;
        case GrKey_Down : cselec = min( 3,cselec+1 ); break;
        }
      pintar[cselec][opc[cselec]] = 1;
      }
    else if( ev == EV_AREA ){
      b1 = c >> 8; b2 = c & 0xFF;
      if( b1 > 0 && b1 < 4 && b2 >0 && b2 < 5 ){
        pintar[cselec][opc[cselec]] = 1;
        cselec = b2 - 1;
        pintar[cselec][opc[cselec]] = 1;
        opc[cselec] = b1 - 1;
        pintar[cselec][opc[cselec]] = 1;
        }
      }
    }

//  oculta_raton();

  GrBitBlt( NULL,x,y,grc,0,0,285,236,GrWRITE );
  GrDestroyContext( grc );

  asigna_raton1();
//  muestra_raton();

  *j1 = opc[0]; *j2 = opc[1]; *j3 = opc[2]; *j4 = opc[3];
  if( c == GrKey_Escape ) return 1;
  return 0;
}

/************************************************************************/

int elige_idioma( int x, int y )
{
  GrContext * grc;
  int ev, c, r = -2, activo = 0;

//  oculta_raton();
  asigna_raton4( x,y );

  grc = GrCreateContext( 210,49,NULL,NULL );
  if( grc == NULL ) termina_mal( "Falta memoria (out of memory)" );
  GrBitBlt( grc,0,0,NULL,x,y,x+209,y+48,GrWRITE );

  GrBox( x,y,x+209,y+48,K_BLACK );
  GrBox( x+1,y+1,x+208,y+47,K_CYAN );
  GrBox( x+2,y+2,x+207,y+46,K_CYAN );
  GrBox( x+3,y+3,x+206,y+45,K_BLACK );
  GrFilledBox( x+4,y+4,x+205,y+44,K_WHITE );

  while( r == -2 ){
    dboton( x+10,y+10,90,30,K_LIGHTGRAY,K_BLACK,
           "Español",(activo == 0) ? 2 : 0 );
    dboton( x+110,y+10,90,30,K_LIGHTGRAY,K_BLACK,
           "English",(activo == 1) ? 2 : 0 );
//    muestra_raton();
    ev = lee_evento( &c,1 );
    if( ev == EV_TECLA ){
      switch( c ){
        case GrKey_Left  :
        case GrKey_Right : activo = (activo + 1) % 2;
                           break;
        case GrKey_Return: if( activo == 0 )
                             r = ESPANOL;
                           else
                             r = ENGLISH;
                           break;
        case GrKey_Escape: r = -1;
                           break;
        case 'E'         : r = ESPANOL;
                           break;
        case 'G'         : r = ENGLISH;
                           break;
        }
      }
//    oculta_raton();
    }

  GrBitBlt( NULL,x,y,grc,0,0,209,48,GrWRITE );
  GrDestroyContext( grc );

  asigna_raton1();
//  muestra_raton();

  return r;
}

/************************************************************************/

void ha_llegado( int x, int y, struct Tablero *tbl )
{
  static char *tcj[4];
  static char *tor[4];
  GrContext * grc;
  GrTextOption grt;
  int orden, cj, c;

  tcj[0] = SL_AMARILLO;
  tcj[1] = SL_AZUL;
  tcj[2] = SL_ROJO;
  tcj[3] = SL_VERDE;
  tor[0] = SL_PRIMERO;
  tor[1] = SL_SEGUNDO;
  tor[2] = SL_TERCERO;
  tor[3] = SL_ULTIMO;

//  oculta_raton();
  asigna_raton3();
  cj = tbl->turno;
  orden = tbl->orden_final[cj] = tbl->siguiente_final++;

  grc = GrCreateContext( 286,204,NULL,NULL );
  if( grc == NULL ) termina_mal( "Falta memoria (out of memory)" );
  GrBitBlt( grc,0,0,NULL,x,y,x+285,y+203,GrWRITE );

  GrBox( x,y,x+285,y+203,K_BLACK );
  GrBox( x+1,y+1,x+284,y+202,colores_tbl[cj] );
  GrBox( x+2,y+2,x+283,y+201,colores_tbl[cj] );
  GrBox( x+3,y+3,x+282,y+200,K_BLACK );
  GrFilledBox( x+4,y+4,x+281,y+199,K_WHITE );

  grt.txo_fgcolor = K_BLACK;
  grt.txo_bgcolor = K_BLACK | GrOR;
  grt.txo_direct = GR_TEXT_RIGHT;
  grt.txo_xalign = GR_ALIGN_CENTER;
  grt.txo_yalign = GR_ALIGN_CENTER;
  grt.txo_chrtype = GR_UTF8_TEXT;

  grt.txo_font = grf_normal;
  GrDrawString( tcj[cj],0,x+286/2,y+40,&grt );
  GrDrawString( SL_LLEGADO,0,x+286/2,y+80,&grt );
  GrDrawString( tor[orden],0,x+286/2,y+120,&grt );
//  grt.txo_font = &GrFont_PC8x16;
  grt.txo_font = grf_texto;
  GrDrawString( SL_CONTINUA,0,x+286/2,y+175,&grt );
//  muestra_raton();

  lee_evento( &c,1 );
//  oculta_raton();
  GrBitBlt( NULL,x,y,grc,0,0,285,203,GrWRITE );
  GrDestroyContext( grc );
//  muestra_raton();
  asigna_raton1();
}

/************************************************************************/

void partida_acabada( struct Tablero *tbl )
{
  static char *mensaje[4];
  int i, j;

  mensaje[0] = ST_FIN1;
  mensaje[1] = ST_FIN2;
  mensaje[2] = ST_FIN3;
  mensaje[3] = ST_FIN4;

  pinta_dado( 0 );
  while( 1 )
    for( i=AMAR; i<=VERD; i++ ){
      pinta_tirador( i,mensaje[i] );
      for( j=0; j<12; j++ ){
        if( hay_orden( tbl ) == -1 ) return;
        GrSleep( 50 );
        }
    }
}

/************************************************************************/

int espera_orden( struct Tablero *tbl )
{
  int ev, c;

  while( 1 ){
    ev = lee_orden( tbl,&c,1 );
    if( ev == -1 ) return -1;
    if( (ev == EV_TECLA) && (c == GrKey_Return) ) return 0;
    }
}

/************************************************************************/

int hay_orden( struct Tablero *tbl )
{
  int ev, c;

  ev = lee_orden( tbl,&c,0 );
  if( ev == -1 ) return -1;
  return 0;
}

/************************************************************************/

int lee_orden( struct Tablero *tbl, int *valor, int espera )
{
  int ev, j1 = 0, j2 = 0, j3 = 0, j4 = 0;

  while( 1 ){
    ev = lee_evento( valor,espera );
    if( ev != EV_TECLA ) return ev;
    switch( *valor ){
      case 'N': j1 = tbl->jugador[0].tipo;
                j2 = tbl->jugador[1].tipo;
                j3 = tbl->jugador[2].tipo;
                j4 = tbl->jugador[3].tipo;
                if( quien_juega( 177,138,&j1,&j2,&j3,&j4 ) == 0 ){
                quita_fichasg( tbl );
                inicia_tablero( tbl );
                inicia_jugadores( tbl,j1,j2,j3,j4 );
                  situa_fichasg( tbl );
                  return -1;
                  }
                break;
      case GrKey_Escape :
      case 'S': termina();
                break;
      case 'I': info( tbl );
                break;
      case GrKey_F1:
      case 'A': ayuda( tbl );
                break;
      case 'R': if (GrSoundIsEnabled()) {
                  GrSoundDisable();
                }
                else {
                  GrSoundEnable();
                  GrSoundPlaySound(70, 50);
                }
                break;
      default : return ev;
      }
    }
}

/************************************************************************/

void termina_mal( char *mensaje )
{
//  oculta_raton();
  gfaz_fin();
  printf( "Parchis: %s\n",mensaje );
//  printf( "Pulsa una tecla para continuar (press any key to continue)\n" );
//  while( !GrKeyPressed() );
  exit(1);
}

/************************************************************************/

void termina( void )
{
//  oculta_raton();
  gfaz_fin();
  exit(0);
}

/************************************************************************/

void asigna_raton1( void )
{
  static struct AreaRaton area[] = {
    { 492,120,544,166,1,1,0,0,0,'A',0 },   // botones
    { 546,120,598,166,1,1,0,0,0,'I',0 },
    { 492,168,544,214,1,1,0,0,0,'N',0 },
    { 546,168,598,214,1,1,0,0,0,'S',0 },
    { 492,216,544,262,1,1,0,0,0,GrKey_Left,0 },
    { 546,216,598,262,1,1,0,0,0,'R',0 },
    { 492,297,598,321,1,1,0,0,0,GrKey_Return,0 },
    { 305,172,444,217,7,2,-1,-1,7,2,0 },   // corredor
    { 294,184,304,195,1,1,0,0,8,2,0 },
    { 285,196,304,217,1,1,0,0,8,1,0 },
    { 281,172,294,184,1,1,0,0,9,2,0 },
    { 259,172,280,192,1,1,0,0,9,1,0 },
    { 259, 32,304,171,2,7,1,-1,1,16,1 },
    { 213, 32,258, 51,2,1,1,0,1,17,1 },    // 1ss
    { 167, 32,212,171,2,7,-1,1,2,18,1 },
    { 191,172,212,191,1,1,0,0,25,1,0 },
    { 177,172,190,183,1,1,0,0,25,2,0 },
    { 167,182,178,195,1,1,0,0,26,2,0 },
    { 167,201,186,217,1,1,0,0,26,1,0 },
    {  27,172,166,217,7,2,-1,-1,33,2,0 },
    {  27,218, 46,263,1,2,0,1,34,1,0 },    // 2ss
    {  27,264,166,309,7,2,1,1,35,1,0 },
    { 167,264,186,285,1,1,0,0,42,1,0 },
    { 167,286,178,298,1,1,0,0,42,2,0 },
    { 178,298,191,309,1,1,0,0,43,2,0 },
    { 192,290,212,309,1,1,0,0,43,1,0 },
    { 167,310,212,449,2,7,-1,1,2,44,1 },
    { 213,430,258,449,2,1,1,0,1,51,1 },    // 3ss
    { 259,310,304,449,2,7,1,-1,1,58,1 },
    { 259,290,280,309,1,1,0,0,59,1,0 },
    { 281,299,294,309,1,1,0,0,59,2,0 },
    { 293,286,304,298,1,1,0,0,60,2,0 },
    { 285,264,304,285,1,1,0,0,60,1,0 },
    { 305,264,444,309,7,2,1,1,61,1,0 },
    { 425,218,444,263,1,2,0,1,68,1,0 },    // 4ss
    { 285,218,424,263,7,2,-1,1,107,1,0 },  // salidas
    { 213, 52,258,191,2,7,1,1,1,111,1 },
    {  47,218,186,263,7,2,1,1,121,1,0 },
    { 213,290,258,429,2,7,1,-1,1,137,1 },
    { 187,192,284,289,1,1,0,0,150,1,0 } }; // meta

  asigna_area_raton( 0,0,area,40,fespera1 );
}

/************************************************************************/

void fespera1( int es_tecla, int c )
{
  static int x = 490, y = 118;
#ifdef DEPURAR
  char s[81];
#endif

//  oculta_raton();

  if( es_tecla ){
    if( c == 'A' ) dboton( x,y,56,50,K_GREEN,K_BLACK,SB_AYUDA,5 );
    if( c == 'I' ) dboton( x+54,y,56,50,K_GREEN,K_BLACK,SB_INFO,5 );
    if( c == 'N' ) dboton( x,y+48,56,50,K_GREEN,K_BLACK,SB_NUEVO,5 );
    if( c == 'S' ) dboton( x+54,y+48,56,50,K_GREEN,K_BLACK,SB_SALIR,5 );
    if( c == GrKey_Left ) dboton( x,y+96,56,50,K_GREEN,K_BLACK,SB_FICHA,5 );
    if( c == 'R' ) dboton( x+54,y+96,56,50,K_GREEN,K_BLACK,SB_RUIDO,5 );
    if( c == GrKey_Return )
      dboton( 490,295,110,28,colores_tbl[glob_tc],K_BLACK,glob_ts,5 );
    }

#ifdef DEPURAR
  sprintf( s,"%i,%i",((unsigned int)c)>>8,c&255 );
  dboton( 0,0,90,30,K_WHITE,K_BLACK,s,0 );
#endif

//  muestra_raton();
  espera_soltar_raton();
//  oculta_raton();

  if( es_tecla ){
    if( c == 'A' ) dboton( x,y,56,50,K_GREEN,K_BLACK,SB_AYUDA,0 );
    if( c == 'I' ) dboton( x+54,y,56,50,K_GREEN,K_BLACK,SB_INFO,0 );
    if( c == 'N' ) dboton( x,y+48,56,50,K_GREEN,K_BLACK,SB_NUEVO,0 );
    if( c == 'S' ) dboton( x+54,y+48,56,50,K_GREEN,K_BLACK,SB_SALIR,0 );
    if( c == GrKey_Left ) dboton( x,y+96,56,50,K_GREEN,K_BLACK,SB_FICHA,0 );
    if( c == 'R' ) dboton( x+54,y+96,56,50,K_GREEN,K_BLACK,SB_RUIDO,0 );
    if( c == GrKey_Return )
      dboton( 490,295,110,28,colores_tbl[glob_tc],K_BLACK,glob_ts,0 );
    }
    
//  muestra_raton();
}

/************************************************************************/

void asigna_raton2( int x, int y )
{
  static struct AreaRaton area[] = {
    {  10, 40,274,194,3,4,1,1,1,1,0 },
    {  12,202, 98,228,1,1,0,0,0,GrKey_Escape,0 },
    { 188,202,276,228,1,1,0,0,0,GrKey_Return,0 } };

  glob_xqj = x;
  glob_yqj = y;
  asigna_area_raton( x,y,area,3,fespera2 );
}

/************************************************************************/

void fespera2( int es_tecla, int c )
{
  if( !es_tecla ) return;
  
//  oculta_raton();
  if( c == GrKey_Escape )
    dboton( glob_xqj+10,glob_yqj+200,90,30,K_LIGHTGRAY,K_BLACK,SB_CANCELAR,5 );
  if( c == GrKey_Return )
    dboton( glob_xqj+186,glob_yqj+200,90,30,K_LIGHTGRAY,K_BLACK,SB_VALE,5 );
//  muestra_raton();
  espera_soltar_raton();
//  oculta_raton();
  if( c == GrKey_Escape )
    dboton( glob_xqj+10,glob_yqj+200,90,30,K_LIGHTGRAY,K_BLACK,SB_CANCELAR,0 );
  if( c == GrKey_Return )
    dboton( glob_xqj+186,glob_yqj+200,90,30,K_LIGHTGRAY,K_BLACK,SB_VALE,0 );
//  muestra_raton();
}

/************************************************************************/

void asigna_raton3( void )
{
  asigna_area_raton( 0,0,NULL,0,NULL );
}

/************************************************************************/

void asigna_raton4( int x, int y )
{
  static struct AreaRaton area[] = {
    {  10, 10,100, 40,1,1,0,0,0,'E',0 },
    { 110, 10,200, 40,1,1,0,0,0,'G',0 } };

  glob_xqj = x;
  glob_yqj = y;
  asigna_area_raton( x,y,area,2,fespera4 );
}

/************************************************************************/

void fespera4( int es_tecla, int c )
{
  if( !es_tecla ) return;
  
//  oculta_raton();
  if( c == 'E' )
    dboton( glob_xqj+10,glob_yqj+10,90,30,K_LIGHTGRAY,K_BLACK,"Español",5 );
  if( c == 'G' )
    dboton( glob_xqj+110,glob_yqj+10,90,30,K_LIGHTGRAY,K_BLACK,"English",5 );
//  muestra_raton();
  espera_soltar_raton();
//  oculta_raton();
  if( c == 'E' )
    dboton( glob_xqj+10,glob_yqj+10,90,30,K_LIGHTGRAY,K_BLACK,"Español",0 );
  if( c == 'G' )
    dboton( glob_xqj+110,glob_yqj+10,90,30,K_LIGHTGRAY,K_BLACK,"English",0 );
//  muestra_raton();
}

/************************************************************************/

#ifdef DEPURAR
void pinta_anal_global( struct JugadasPosibles *jpo, int *valores )
{
  GrTextOption grt;
  GrContext * grc;
  char s[81];
  int i, x2, c;
  int x = 10, y = 10;

//  oculta_raton();
  asigna_raton3();

//  grt.txo_font = &GrFont_PC8x14;
  grt.txo_font = grf_texto;
  grt.txo_fgcolor = K_BLUE;
  grt.txo_bgcolor = K_BLACK | GrOR;
  grt.txo_direct = GR_TEXT_RIGHT;
  grt.txo_xalign = GR_ALIGN_LEFT;
  grt.txo_yalign = GR_ALIGN_TOP;
  grt.txo_chrtype = GR_UTF8_TEXT;

  grc = GrCreateContext( 286,204,NULL,NULL );
  if( grc == NULL ) termina_mal( "Falta memoria (out of memory)" );
  GrBitBlt( grc,0,0,NULL,x,y,x+285,y+203,GrWRITE );

  GrBox( x,y,x+285,y+203,K_BLACK );
  GrBox( x+1,y+1,x+284,y+202,K_WHITE );
  GrBox( x+2,y+2,x+283,y+201,K_WHITE );
  GrBox( x+3,y+3,x+282,y+200,K_BLACK );
  GrFilledBox( x+4,y+4,x+281,y+199,K_WHITE );

  GrDrawString( "entra",5,x+10,y+10,&grt );
  GrDrawString( "sale",4,x+10,y+20,&grt );
  GrDrawString( "meta",4,x+10,y+30,&grt );
  GrDrawString( "come",4,x+10,y+40,&grt );
  GrDrawString( "hpte",4,x+10,y+50,&grt );
  GrDrawString( "rpte",4,x+10,y+60,&grt );
  GrDrawString( "dseg",4,x+10,y+70,&grt );
  GrDrawString( "aseg",4,x+10,y+80,&grt );
  GrDrawString( "nficom",6,x+10,y+90,&grt );
  GrDrawString( "nfipel",6,x+10,y+100,&grt );
  GrDrawString( "nffcom",6,x+10,y+110,&grt );
  GrDrawString( "nffpel",6,x+10,y+120,&grt );
  GrDrawString( "ncfin",5,x+10,y+130,&grt );
  GrDrawString( "nficha",6,x+10,y+140,&grt );
  GrDrawString( "vdado",5,x+10,y+150,&grt );
  GrDrawString( "valor",5,x+10,y+160,&grt );

  for( i=0; i<jpo->njugadas; i++ ){
    x2 = x + 70 + i * 50;
    sprintf( s,"%i",jpo->jugada[i].anal.entra );
    GrDrawString( s,0,x2,y+10,&grt );
    sprintf( s,"%i",jpo->jugada[i].anal.sale );
    GrDrawString( s,0,x2,y+20,&grt );
    sprintf( s,"%i",jpo->jugada[i].anal.meta );
    GrDrawString( s,0,x2,y+30,&grt );
    sprintf( s,"%i",jpo->jugada[i].anal.come );
    GrDrawString( s,0,x2,y+40,&grt );
    sprintf( s,"%i",jpo->jugada[i].anal.hpte );
    GrDrawString( s,0,x2,y+50,&grt );
    sprintf( s,"%i",jpo->jugada[i].anal.rpte );
    GrDrawString( s,0,x2,y+60,&grt );
    sprintf( s,"%i",jpo->jugada[i].anal.dseg );
    GrDrawString( s,0,x2,y+70,&grt );
    sprintf( s,"%i",jpo->jugada[i].anal.aseg );
    GrDrawString( s,0,x2,y+80,&grt );
    sprintf( s,"%i",jpo->jugada[i].anal.nficom );
    GrDrawString( s,0,x2,y+90,&grt );
    sprintf( s,"%i",jpo->jugada[i].anal.nfipel );
    GrDrawString( s,0,x2,y+100,&grt );
    sprintf( s,"%i",jpo->jugada[i].anal.nffcom );
    GrDrawString( s,0,x2,y+110,&grt );
    sprintf( s,"%i",jpo->jugada[i].anal.nffpel );
    GrDrawString( s,0,x2,y+120,&grt );
    sprintf( s,"%i",jpo->jugada[i].anal.ncfin );
    GrDrawString( s,0,x2,y+130,&grt );
    sprintf( s,"%i",jpo->jugada[i].nficha );
    GrDrawString( s,0,x2,y+140,&grt );
    sprintf( s,"%i",jpo->jugada[i].vdado );
    GrDrawString( s,0,x2,y+150,&grt );
    sprintf( s,"%i",valores[i] );
    GrDrawString( s,0,x2,y+160,&grt );
    }

//  muestra_raton();
  lee_evento( &c,1 );
//  oculta_raton();
  GrBitBlt( NULL,x,y,grc,0,0,285,203,GrWRITE );
  GrDestroyContext( grc );
//  muestra_raton();
  asigna_raton1();
}
#endif

/************************************************************************/

void info( struct Tablero *tbl )
{
  static char *pagina[2][11] = {   // 11 lineas
   {"                 PARCHÍS Versión 4.1",
    "  Copyright (C) 1992-2017 Mariano Alvarez Fernandez",
    "",
    "        Este programa es Software Libre, puede",
    "          usarse, distribuirse y modificarse",
    "        libremente bajo las condiciones de la",
    "      GNU General Public License. Lee el fichero",
    "          leeme.txt para  más informacion.",
    "",
    "",
    "malfer at telefonica.net" },
   {"                 PARCHÍS Version 4.1",
    "  Copyright (C) 1992-2017 Mariano Alvarez Fernandez",
    "",
    "    This program is free software; you can use it,",
    "   redistribute it and/or modify it under the terms",
    "     of the GNU General Public License. Read the",
    "       README.TXT file for more information.",
    "",
    "",
    "",
    "malfer at telefonica.net" } };

  GrTextOption grt;
  int i, c;

//  grt.txo_font = &GrFont_PC8x14;
  grt.txo_font = grf_texto;
  grt.txo_fgcolor = K_BLUE;
  grt.txo_bgcolor = K_BLACK | GrOR;
  grt.txo_direct = GR_TEXT_RIGHT;
  grt.txo_xalign = GR_ALIGN_LEFT;
  grt.txo_yalign = GR_ALIGN_BOTTOM;
  grt.txo_chrtype = GR_UTF8_TEXT;
  asigna_raton3();
  
//  oculta_raton();
  GrBox( 22,27,450,455,K_BLACK );
  GrFilledBox( 23,28,449,454,K_WHITE );
  for( i=0; i<11; i++ )
    GrDrawString( pagina[idioma][i],0,25,47+i*12,&grt );
  GrDrawString( SL_CONTINUA,0,25,47+32*12,&grt );
//  muestra_raton();
  lee_evento( &c,1 );
    
  dibuja_tablero();
  situa_fichasg( tbl );
  asigna_raton1();
}

/************************************************************************/

void ayuda( struct Tablero *tbl )
{
  static char *pagina1[] = {  /* 26 lineas */
    "                 PARCHÍS Versión 4.1",
    "  Copyright (C) 1992-2017 Mariano Alvarez Fernandez",
    "",
    "  El juego del parchís es ampliamente conocido, aquí",
    "se describen sólo las reglas a que se atiene el pro-",
    "grama:",
    "",
    " 1.  Al sacar un 5, es obligado sacar una ficha de",
    "     casa, si hay.",
    " 2.  La primera vez que se saca un 5, se sacan dos",
    "     fichas de casa.",
    " 3.  6 cuenta 7, si no quedan fichas en casa.",
    " 4.  Al comer una ficha, se cuentan 20.",
    " 5.  Al llegar a la meta, se cuentan 10.",
    " 6.  Si se saca un 6, se vuelve a jugar.",
    " 7.  Si se sacan 3 seises seguidos, se manda a casa",
    "     la última ficha jugada, salvo que esté ya en el",
    "     corredor de entrada a meta.",
    " 8.  Si se saca un 6, se está obligado a abrir puen-",
    "     te si lo hay.",
    " 9.  No se puede pasar a través de un puente.",
    "10.  No se pueden comer las fichas que están en se-",
    "     guro, excepto cuando se saca 5 y hay que hacer",
    "     sitio para meter una ficha en juego.",
    "11.  Para entrar en la meta, hay que sacar el número",
    "     exacto." };

  static char *pagina2[] = {   /* 21 lineas */
    "  El programa permite jugar de 1 a 4 jugadores, que",
    "pueden ser personas, ó estar controlados por el pro-",
    "grama. La combinación de jugadores se elige al comen-",
    "zar el juego, usando las teclas del cursor.",
    "",
    "  Durante el juego aparece, en la parte derecha, la",
    "acción a realizar. Para ejecutarla, pulsar Retorno.",
    "En la acción de Mover se elige la ficha a jugar, con",
    "los cursores izquierdo y derecho, antes de pulsar",
    "Retorno.",
    "",
    "  En cualquier momento del juego, se admiten las",
    "siguientes ordenes:",
    "",
    "Tecla    Orden",
    "-------  --------------------------------------------",
    "A o F1   Ayuda, muestra estas pantallas de ayuda.",
    "I        Info, muestra información adicional.",
    "N        Nuevo, comenzar una nueva partida.",
    "R        Ruido, activa o desactiva el ruido.",
    "S o Esc  Salir, terminar el juego." };

  static char *pagina3[] = {   /* 11 lineas */
    "              FUNCIONAMIENTO CON RATÓN",
    "",
    "  Pulsar sobre los botones de la parte derecha de ",
    "la pantalla, realiza la acción indicada en el botón.",
    "",
    "  La elección de la ficha y el movimiento puede rea-",
    "lizarse de dos formas:",
    "  - con el botón 'ficha' se elige la ficha y después",
    "    se pulsa 'Mueves'.",
    "  - pulsar sobre la ficha que se desea mover y luego",
    "    sobre la casilla a donde se quiere mover." };

  GrTextOption grt;
  int i, p, c;
  char s[81];

//  grt.txo_font = &GrFont_PC8x14;
  grt.txo_font = grf_texto;
  grt.txo_fgcolor = K_BLUE;
  grt.txo_bgcolor = K_BLACK | GrOR;
  grt.txo_direct = GR_TEXT_RIGHT;
  grt.txo_xalign = GR_ALIGN_LEFT;
  grt.txo_yalign = GR_ALIGN_BOTTOM;
  grt.txo_chrtype = GR_UTF8_TEXT;
  asigna_raton3();
  
  for( p=0; p<3; p++ ){
//    oculta_raton();
    GrBox( 22,27,450,455,K_BLACK );
    GrFilledBox( 23,28,449,454,K_WHITE );
    switch( p ){
      case 0: for( i=0; i<26; i++ )
                GrDrawString( pagina1[i],0,25,47+i*12,&grt );
              break;
      case 1: for( i=0; i<21; i++ )
                GrDrawString( pagina2[i],0,25,47+i*12,&grt );
              break;
      case 2: for( i=0; i<11; i++ )
                GrDrawString( pagina3[i],0,25,47+i*12,&grt );
              break;
      }
    if( idioma == ENGLISH ){
      GrDrawString( "Sorry!! I don't have translated the help yet!",
                    45,25,47+29*12,&grt );
      GrDrawString( "it will be nice if you can do it for me :-)",
                    43,25,47+30*12,&grt );
      sprintf( s,"Page %d of %d                Press any key to continue",
               p+1,3 );
      }
    else {
      sprintf( s,"Página %d de %d         Pulsa una tecla para continuar",
               p+1,3 );
      }
    GrDrawString( s,0,25,47+32*12,&grt );
//    muestra_raton();
    lee_evento( &c,1 );
    }
    
  dibuja_tablero();
  situa_fichasg( tbl );
  asigna_raton1();
}

